Name:           oracle-jdbc
Version:        9.2.0.4
Release:        1jpp
Epoch:          0
Summary:        Official JDBC driver for Oracle

Group:          System Environment/Libraries
License:        Proprietary
Distribution:   JPackage
Vendor:         JPackage Project
URL:            http://otn.oracle.com/software/tech/java/sqlj_jdbc/index.html
Source0:        p3095277_9204_LINUX.zip        
NoSource:       0
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  unzip, cpio, java-devel, jpackage-utils >= 0:1.5, sed
Requires:       java, jpackage-utils >= 0:1.5
Requires:	%{name}-thin = %{epoch}:%{version}-%{release}

%description
This package provides the JDBC connectivity files as extracted from Oracle
latest database patchset. It is intended to provide a lightweight alternative
to a full Oracle client installation. It is by no means thoroughly tested nor
is it endorsed by Oracle. Use at your own risk.

You need a metalink access to pull the source Oracle patchset.

This package includes the libraries needed for JNI oci connectivity and the
generic additional rowset support.


%package java12
Summary:        Official Java 1.2 JDBC thin driver for Oracle
Group:          System Environment/Libraries
Requires:       jpackage-utils >= 0:1.5, java >= 0:1.3.0, java < 0:1.4.0
Provides:	%{name}-thin

%description    java12
This package provides the JDBC connectivity files as extracted from Oracle
latest database patchset. It is intended to provide a lightweight alternative
to a full Oracle client installation. It is by no means thoroughly tested nor
is it endorsed by Oracle. Use at your own risk.
                                                                                                                              
You need a metalink access to pull the source Oracle patchset.
                                                                                                                              
This package includes the jars needed for generic java 1.2/1.3 thin driver
connectivity.


%package java14
Summary:        Official Java 1.4 JDBC thin driver for Oracle
Group:          System Environment/Libraries
Requires:       jpackage-utils >= 0:1.5, java >= 0:1.4.0, java < 0:1.5.0
Provides:       %{name}-thin

 
%description    java14
This package provides the JDBC connectivity files as extracted from Oracle
latest database patchset. It is intended to provide a lightweight alternative
to a full Oracle client installation. It is by no means thoroughly tested nor
is it endorsed by Oracle. Use at your own risk.
                                                                                                                              
You need a metalink access to pull the source Oracle patchset.
                                                                                                                              
This package includes the jars needed for generic java 1.4 thin driver
connectivity.


%prep

%setup -n %{name}-%{version}-%{release} -c -T
unzip %{SOURCE0} patchnote.css  README.html
unzip -p %{SOURCE0} | cpio -idmv \
   Disk1/stage/Patches/oracle.java.jdbc.oci_common/9.2.0.4.0/1/DataFiles/oci.2.2.jar \
   Disk1/stage/Patches/oracle.rsf.rdbms_rsf/9.2.0.4.0/1/DataFiles/lib.1.1.jar \
   Disk1/stage/Patches/oracle.rsf.clntsh_rsf/9.2.0.4.0/1/DataFiles/lib.1.1.jar \
   Disk1/stage/Patches/oracle.java.jdbc.thin12/9.2.0.4.0/1/DataFiles/jdk12.1.1.jar \
   Disk1/stage/Patches/oracle.java.jdbc.thin14/9.2.0.4.0/1/DataFiles/jdk14.1.1.jar \
   Disk1/stage/Patches/oracle.java.jdbc.jdbc_common/9.2.0.4.0/1/DataFiles/lib.1.1.jar

. %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && export JAVA_HOME=%{_jvmdir}/java

# OCI files - on a standard oracle install libclntsh.so.9.0 would be relinked
$JAVA_HOME/bin/jar -xvf Disk1/stage/Patches/oracle.java.jdbc.oci_common/9.2.0.4.0/1/DataFiles/oci.2.2.jar
$JAVA_HOME/bin/jar -xvf Disk1/stage/Patches/oracle.rsf.rdbms_rsf/9.2.0.4.0/1/DataFiles/lib.1.1.jar libwtc9.so
$JAVA_HOME/bin/jar -xvf Disk1/stage/Patches/oracle.rsf.clntsh_rsf/9.2.0.4.0/1/DataFiles/lib.1.1.jar libclntsh.so.9.0

# Thin drivers
$JAVA_HOME/bin/jar -xvf Disk1/stage/Patches/oracle.java.jdbc.thin12/9.2.0.4.0/1/DataFiles/jdk12.1.1.jar classes12.jar nls_charset12.jar
$JAVA_HOME/bin/jar -xvf Disk1/stage/Patches/oracle.java.jdbc.thin14/9.2.0.4.0/1/DataFiles/jdk14.1.1.jar ojdbc14.jar
$JAVA_HOME/bin/jar -xvf Disk1/stage/Patches/oracle.java.jdbc.jdbc_common/9.2.0.4.0/1/DataFiles/lib.1.1.jar ocrs12.jar

%install
rm -rf $RPM_BUILD_ROOT
install -d -m 0755 $RPM_BUILD_ROOT/%{_jnidir}-{ext,1.3.0,1.3.1,1.4.0,1.4.1,1.4.2}
install -d -m 0755 $RPM_BUILD_ROOT/%{_jnidir}
install -d -m 0755 $RPM_BUILD_ROOT/%{_libdir}


install -m 0755 *.so *.so.* $RPM_BUILD_ROOT/%{_libdir}

install -m 0644 classes12.jar $RPM_BUILD_ROOT/%{_jnidir}-ext/%{name}-java12-%{version}.jar
install -m 0644 nls_charset12.jar  $RPM_BUILD_ROOT/%{_jnidir}-ext/%{name}-nls-java12-%{version}.jar
install -m 0644 ojdbc14.jar $RPM_BUILD_ROOT/%{_jnidir}-ext/%{name}-java14-%{version}.jar
install -m 0644 ocrs12.jar $RPM_BUILD_ROOT/%{_jnidir}/%{name}-ocrs-%{version}.jar

# Symlink madness
pushd $RPM_BUILD_ROOT/%{_jnidir}-ext
   for jar in *-%{version}.jar ; do
      ln -s ${jar} $(echo $jar | sed "s+-%{version}.jar+.jar+g")
   done
popd
pushd $RPM_BUILD_ROOT/%{_jnidir}
   ln -s %{name}-ocrs-%{version}.jar %{name}-ocrs.jar
popd

# Register jars in in the correct version-specific directories
pushd $RPM_BUILD_ROOT/%{_jnidir}-ext
for ending in .jar -%{version}.jar ; do
   for javaver in 1.3.0 1.3.1 ; do
      pushd $RPM_BUILD_ROOT/%{_jnidir}-$javaver
         ln -s %{_jnidir}-ext/%{name}-java12$ending %{name}$ending
         ln -s %{_jnidir}-ext/%{name}-nls-java12$ending %{name}-nls$ending
      popd
   done
   for javaver in 1.4.0 1.4.1 1.4.2 ; do
      pushd $RPM_BUILD_ROOT/%{_jnidir}-$javaver
         ln -s %{name}-java14$ending $RPM_BUILD_ROOT/%{_jnidir}-$javaver/%{name}$ending
      popd
   done
done

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%defattr(0644,root,root,0755)
%doc README.html patchnote.css
%defattr(0755,root,root,0755)
%{_libdir}/*.so.*
%{_libdir}/*.so
%{_jnidir}/*.jar

%files java12
%defattr(0644,root,root,0755)
%{_jnidir}-1.3.0/*.jar
%{_jnidir}-1.3.1/*.jar
%{_jnidir}-ext/*java12*.jar

%files java14
%defattr(0644,root,root,0755)
%{_jnidir}-1.4.0/*.jar
%{_jnidir}-1.4.1/*.jar
%{_jnidir}-1.4.2/*.jar
%{_jnidir}-ext/*java14*.jar

%changelog
* Tue Jan 13 2004 Nicolas Mailhot <Nicolas.Mailhot (at) laposte.net> - 0:9.2.0.4-1jpp
- Initial RPM release - totally untested - be careful and report packaging bugs.
